VERSION 2.00
Begin Form Form1 
   BackColor       =   &H00C0C0C0&
   Caption         =   "Database Table Structure Printer"
   ClientHeight    =   2670
   ClientLeft      =   1875
   ClientTop       =   2640
   ClientWidth     =   4125
   Height          =   3360
   Left            =   1815
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2670
   ScaleWidth      =   4125
   Top             =   2010
   Width           =   4245
   Begin ListBox lst_Tables 
      Height          =   2175
      Left            =   120
      TabIndex        =   0
      Top             =   252
      Width           =   3855
   End
   Begin CommonDialog CMDialog1 
      DefaultExt      =   "mdb"
      DialogTitle     =   "Open Database"
      Filter          =   "Access Database|*.mdb"
      Left            =   -360
      Top             =   0
   End
   Begin Label Label1 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Print Which Table?"
      Height          =   195
      Left            =   120
      TabIndex        =   1
      Top             =   30
      Width           =   1650
   End
   Begin Menu mnu_File 
      Caption         =   "&File"
      Begin Menu mnu_OpenDB 
         Caption         =   "&Open"
      End
      Begin Menu mnu_Print 
         Caption         =   "&Print"
         Enabled         =   0   'False
      End
      Begin Menu mnu_Line 
         Caption         =   "-"
      End
      Begin Menu mnu_Exit 
         Caption         =   "E&xit"
      End
   End
   Begin Menu mnu_Help 
      Caption         =   "&Help"
      Begin Menu mnu_About 
         Caption         =   "&About"
      End
   End
End
'Copyright 1993 by Charles Gallo. All Rights Reserved
Dim db As DataBase
Dim td As TableDefs


Sub ChooseDatabase ()
'Copyright 1993 by Charles Gallo. All Rights Reserved
'************************************************************
' Maintenance Header
' Version   Date        Coder                   Action
'   1       07/13/93    C. Gallo(74020,3224)    Initial keyin

' Calls:Nothing

' Is Called By:Form_Load, mnu_OpenDB

' Purpose:To Choose and open a database and add it's tables to
' the listbox


'************************************************************
    'Call the Common Dialog Routine to get the database name
    On Error Resume Next                'This is here if there is no DB Open
    db.Close
    On Error GoTo 0
    lst_Tables.Clear                    'clear the listbox
    mnu_Print.Enabled = False
Retrydatabase:
    On Error GoTo DatabaseError
    CmDialog1.CancelError = True
    CmDialog1.Flags = OFN_FILEMUSTEXIST + OFN_HIDEREADONLY
    CmDialog1.Action = 1
    'Open the database
    Set db = OpenDatabase(CmDialog1.Filetitle)
    On Error GoTo 0
    'loop thru the tables in the database
    For i% = 0 To db.TableDefs.Count - 1
        'if the table is NOT a system table, add it to the listbox
        If (db.TableDefs(i%).Attributes And DB_SYSTEMOBJECT) = 0 Then
            lst_Tables.AddItem db.TableDefs(i%).Name
            mnu_Print.Enabled = True                        'there is something in the listbox so enable print
        End If
    Next
Exit Sub
DatabaseError:
    If Err = 32755 Then             'The user pressed cancel in the cmdialog box
        Exit Sub
    End If
    MsgBox "This is Not a Valid Access Database, or the Database is Corrupt!", MB_ICONEXCLAMATION, "Cagney Systems Inc."
    Resume Retrydatabase

End Sub

Sub Form_Load ()
    'Copyright 1993 by Charles Gallo. All Rights Reserved
    Call Formcenter(Me)
    Me.Show
    x% = DoEvents()
    Call ChooseDatabase
End Sub

Sub Formcenter (dummy As Form)
    Move (screen.Width - dummy.Width) \ 2, (screen.Height - dummy.Height) \ 2
End Sub

Sub lst_Tables_DblClick ()
    'Copyright 1993 by Charles Gallo. All Rights Reserved
    mnu_Print_Click
End Sub

Sub mnu_About_Click ()
    'Copyright 1993 by Charles Gallo. All Rights Reserved
    Temp$ = "Access Database Table Structure Printer" + Chr$(13) + Chr$(10)
    Temp$ = Temp$ + "Copyright by 1993 Charles Gallo. All Rights Reserved" + Chr$(13) + Chr$(10)
    Temp$ = Temp$ + "Charles Gallo (CIS ID 74020,3224)" + Chr$(13) + Chr$(10)
    Temp$ = Temp$ + "This program may be distributed without charge" + Chr$(13) + Chr$(10)
    Temp$ = Temp$ + "As long as the source code, and this statement" + Chr$(13) + Chr$(10)
    Temp$ = Temp$ + "are included"
    MsgBox Temp$, MB_ICONEXCLAMATION, "Cagney Systems Inc."
End Sub

Sub mnu_Exit_Click ()
    'Copyright 1993 by Charles Gallo. All Rights Reserved
    End
End Sub

Sub mnu_OpenDB_Click ()
'Copyright 1993 by Charles Gallo. All Rights Reserved
    Call ChooseDatabase
End Sub

Sub mnu_Print_Click ()
    'Copyright 1993 by Charles Gallo. All Rights Reserved
'************************************************************
' Maintenance Header
' Version   Date        Coder                   Action
'   1       07/13/93    C. Gallo(74020,3224)    Initial keyin

' Calls:Nothing

' Is Called By:lst_Tables_DblClick

' Purpose:To print the stucture of an Access database table


'************************************************************
    'get the tabledef object of the open database
    Set td = db.TableDefs
    td(lst_Tables.Text).Fields.Refresh
    Temp$ = "Table = " + lst_Tables.Text

    'setup the printer and print the header info
    Printer.FontName = "Arial"
    Printer.FontBold = True
    Printer.Print Tab(40 - Len(Temp$) / 2); Temp$
    Printer.FontBold = False
    Printer.Print
    Printer.Print "Field Name"; Tab(40); "Field Type"; Tab(60); "Field Size"
    Printer.Print

    For i% = 0 To td(lst_Tables.Text).Fields.Count - 1               'for all the fields in this table (The table name is form the listbox)
        Printer.Print td(lst_Tables.Text).Fields(i%).Name;           'Print the field name
        Printer.Print Tab(40);                                  'tab to the type column

        'print the field type
        Select Case td(lst_Tables.Text).Fields(i%).Type
            Case DB_BOOLEAN
                Printer.Print "Boolean";
            Case DB_BYTE
                Printer.Print "Byte";
            Case DB_INTEGER
                Printer.Print "Integer";
            Case DB_LONG
                Printer.Print "Long";
            Case DB_CURRENCY
                Printer.Print "Currency";
            Case DB_SINGLE
                Printer.Print "Single";
            Case DB_DOUBLE
                Printer.Print "Double";
            Case DB_DATE
                Printer.Print "Date";
            Case DB_Binary
                Printer.Print "Binary";
            Case DB_TEXT
                Printer.Print "Text";
            Case DB_LONGBINARY
                Printer.Print "BLOB";
            Case DB_MEMO
                Printer.Print "Memo";
            Case Else
                Printer.Print "Error";
        End Select
        Printer.Print Tab(60);                                      'tab to the field size column
        Printer.Print td(lst_Tables.Text).Fields(i%).Size           'and print the field size
    Next
    Printer.EndDoc                              'end the printer doc
'Note: It would be VERY easy to add screen display to this app.
'Just add a second form, put a grid control on the form, and stuff the grid in the loop!

End Sub

